| Home | Libraries | People | FAQ | More

##### http::icy_stream::async_write_some

Start an asynchronous write.

###### Synopsis

    template<
        class ConstBufferSequence,
        class WriteHandler>
    async_write_some(
        ConstBufferSequence const& buffers,
        WriteHandler&& handler);

###### Description

This function is used to asynchronously write one or more bytes of data to the stream. The function call always returns immediately.

###### Parameters

Name | Description
--- | ---
`buffers` | The data to be written to the stream. Although the buffers object may be copied as necessary, ownership of the underlying buffers is retained by the caller, which must guarantee that they remain valid until the handler is called.

`handler`

The completion handler to invoke when the operation completes. The implementation takes ownership of the handler by performing a decay-copy. The equivalent function signature of the handler must be:

    void handler(
      error_code const& error,          // Result of operation.
      std::size_t bytes_transferred     // Number of bytes written.
    );

Regardless of whether the asynchronous operation completes immediately or not, the handler will not be invoked from within this function. Invocation of the handler will be performed in a manner equivalent to using `net::post`.

###### Remarks

The `async_write_some` operation may not transmit all of the data to the peer. Consider using the function `net::async_write` if you need to ensure that all data is written before the asynchronous operation completes.